﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace Ethernet_data
{
    public partial class frmmain : Form
    {
        string reader_type ="";
        const string _reader_tcpip="tcpip";
        const string _reader_com = "com";
        private const string scanreader = "Searching Reader";
        private const string scanreader_ok = "Successful connection   ";
        private const string scanreader_fail = "Please check \n 1、The DL9230 Reader connected? \n 2、If already connected, connect it to the router  \n 3、In the system firewall to allow it";
        private const string ip_fail ="Different network segments, or address conflicts, setting"; //"网段不同或地址冲突，正在设置";
        private const string set_ok = "Set DL9230 Reader IP success";
        private const string set_fail ="Failed to set the IP"; // "设置IP失败";
        private const string start_read = "Start reading Tag";
        private const string stop_read = "Stop Reading Tag";
        private const string nofindreader = "Connection Failed";
        private const string setip_fail = "Set the IP address failed  ";
        private const string setWordMode_fail ="Failed to set the working mode    "; // "设置工作模式失败     ";
        private const string getlocalfail ="Failed to get the PC client IP address";  // "没能获取电脑端IP地址";

        #region  TCPIP  用到的变量

        TcpListener m_sockListener = null;
        public TcpClient m_tcpClient = null;

        private Socket UDP;
        private UdpClient UDP_send;
        private IPEndPoint iep;
        private bool Closeing = false;
        private bool  resing=false ;
        private byte[] receive_data = new byte[1024];
        private string[] ComputerIP = new string[3];
        string[,] network_info = new string[10,4];
        //private RFIDLib.TcpReader_5 tcp_reader = new RFIDLib.TcpReader_5();
        byte reader_Addr = 0;
        #endregion

        #region  COM  用到的变量
        /*************************************************************************/
        public struct TAGDATA
        {
            public byte addr;     //读卡器地址
            public byte volt;     //标签电压 0：正常，1：欠压
            public uint tagID;    //卡号
            public DateTime time; //时间
        }

        delegate void dgAddTagData(List<TAGDATA> listTag);

        byte[] m_sendBuf = new byte[50];
        byte[] m_revBuf = new byte[5000];

        int m_nTagCount = 0;

        public int TagCount
        {
            get
            {
                return m_nTagCount;
            }
            set
            {
                m_nTagCount = value;
            }
        }

        private int m_nTagByteSize = 5;
        /*************************************************************************/
        #endregion

        public frmmain()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
        }
        #region  TCPIP 数据通讯(UDP)

        private bool read_message(byte[] data)
        {
            try
            {
                UDP = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                UDP.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);
                IPEndPoint iep1 = new IPEndPoint(IPAddress.Any, 65534);
                EndPoint Remote = (EndPoint)(iep1);
                UDP.Bind(Remote);

                iep = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 65533);
                UDP_send = new UdpClient();
                UDP_send.Send(data, data.Length, iep);//发送数据
                UDP_send.Close();
                
                autoconnect.Enabled = false;
                bool result = listen();
                return result;
            }
            catch (Exception err)
            {

                MessageBox.Show(err.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }

       

        private bool listen()//监听
        {
            try
            {
                int delaytime = 0;
                while (true)
                {
                    Thread.Sleep(100);
                    if (delaytime++ > 20)
                    {
                        return false;
                    }

                    while (Closeing)
                    {
                        Application.DoEvents();
                    }
                    if (UDP != null)
                    {
                        if (UDP.Available > 0)
                        {
                            delaytime = 0;
                            resing = true;
                            UDP.Receive(receive_data);//返回接受的数据 Encoding.UTF8.GetString
                            resing = false;
                          //  if (receive_data.Length != 208) continue;
                            if (receive_data[207] != 13) continue;

                            if (receive_data[1] == 0x10 && receive_data[2] == 0x04)      //获取设备应答
                            {
                                reader.Ip_Address.MAC = receive_data[72] + "-" + receive_data[73] + "-" + receive_data[74] + "-" + receive_data[75] + "-" + receive_data[76] + "-" + receive_data[77];
                                reader.Ip_Address.IP = receive_data[78] + "." + receive_data[79] + "." + receive_data[80] + "." + receive_data[81];
                                reader.Ip_Address.SubnetMask = receive_data[82] + "." + receive_data[83] + "." + receive_data[84] + "." + receive_data[85];
                                reader.Ip_Address.Gateway = receive_data[86] + "." + receive_data[87] + "." + receive_data[88] + "." + receive_data[89];
                                byte[] name = new byte[21];
                                Array.Copy(receive_data, 90, name, 0, 21);
                                reader.Ip_Address.name = Encoding.Default.GetString(name);

                                reader_name.Text = reader.Ip_Address.name;
                                reader_ip.Text = reader.Ip_Address.IP;
                                reader_SubnetMask.Text = reader.Ip_Address.SubnetMask;
                                reader_Gateway.Text = reader.Ip_Address.Gateway;
                                reader_mac.Text = receive_data[72].ToString("X2") + "-" + receive_data[73].ToString("X2") + "-" + receive_data[74].ToString("X2") + "-" + receive_data[75].ToString("X2") + "-" + receive_data[76].ToString("X2") + "-" + receive_data[77].ToString("X2");
                                return true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x06)      //设置设备IP地址应答
                            {
                                if (receive_data[77] > 0)
                                {
                                    MessageBox.Show(setip_fail, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return false;
                                }
                                return true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x1F)      //设置设备工作模式应答
                            {
                                if (receive_data[119] == 0)
                                {
                                    MessageBox.Show(setWordMode_fail, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return false;
                                }
                                return true;
                            }

                        }
                    }
                    Application.DoEvents();
                }
            }
            finally
            {
                if (UDP != null) UDP.Close();
                autoconnect.Enabled = true;
            }
        }
        #endregion

        //***************************************************************************************************************
        #region 其它事件

        private void Form3_Load(object sender, EventArgs e)
        {
            dataGridView1.RowCount = 0;
            dataGridView1.Columns[2].DefaultCellStyle.ForeColor = Color.Blue;

            comboBox_port.Text = "10000";
            comboBox_Baud.Text = "19200";

            string[] comname = System.IO.Ports.SerialPort.GetPortNames();
            for (int tmp1 = 0; tmp1 < comname.Length; tmp1++)
            {
                ComboBox_com.Items.Add(comname[tmp1]);
            }
            if (ComboBox_com.Items.Count == 1) ComboBox_com.SelectedIndex = 0;

            int network_count = 0;
            Class3.getNetwork(ref network_info, ref network_count); //取本机IP 子网掩码 网关
            for (int i = 0; i < network_count; i++)
            {
                comboBox_ip.Items.Add(network_info[i, 0]);
            }
            if (comboBox_ip.Items.Count == 1) comboBox_ip.SelectedIndex=0;
        }
        private void frmmain_Shown(object sender, EventArgs e)
        {
            //getreaderip_Click(null, null);
        }
        private void frmmain_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (resing)
            {
                Application.DoEvents();
            }
            Closeing = true;
            //tcp_reader.Stop();
            if (m_tcpClient != null) m_tcpClient.Close();
        }
        private void addinfo(string infoname, bool iserror)
        {
            string[] info = new string[2];
            info[0] = (dataGridView2.RowCount + 1).ToString();
            info[1] = DateTime.Now.ToLongTimeString() + "  " + infoname;
            dataGridView2.Rows.Add(info);
            dataGridView2[0,dataGridView2.RowCount - 1].Selected = true;
            if (iserror) dataGridView2.Rows[dataGridView2.RowCount - 1].DefaultCellStyle.ForeColor = Color.Red;
            dataGridView2.FirstDisplayedScrollingRowIndex = dataGridView2.RowCount - 1;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            dataGridView2.RowCount = 0;
        }
        private void reader_ip_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://" + reader_ip.Text);
        }

        private void comboBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789.\b".IndexOf(e.KeyChar) < 0;
        }
        private void comboBox_port_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789\b".IndexOf(e.KeyChar) < 0;
        }

        private void Clearbtn_Click(object sender, EventArgs e)
        {
            dataGridView1.RowCount = 0;
            label7.Text = "0";
        }
        private void tag_show(string addr,string tagID,string time)
        {
            bool findok = false;
            for (int row = 1; row < dataGridView1.RowCount; row++)
            {
                if (tagID== dataGridView1[2, row].Value.ToString())
                {
                    dataGridView1[3, row].Value = time;
                    dataGridView1[4, row].Value = (int.Parse(dataGridView1[4, row].Value.ToString()) + 1).ToString();
                    //dataGridView1[4, row].Selected=true;
                    findok = true;
                    break;
                }

            }
            if (!findok)
            {
                string[] str1 = new string[5];
                str1[0] = (dataGridView1.RowCount + 1).ToString();
                str1[1] = addr;
                str1[2] = tagID;
                str1[3] = time;
                str1[4] = "1";
                dataGridView1.Rows.Add(str1);
                dataGridView1.FirstDisplayedScrollingRowIndex = dataGridView1.RowCount - 1;
            }
            label7.Text = dataGridView1.RowCount.ToString();
        }

        #endregion

        #region  reader connect 连接相关函数或事件

        private void autoconnect_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (!string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
                {
                    getTagbtn_Click(null, null);
                }
                if (serialPort1.IsOpen) btn_closecom_Click(null, null);

                if (Tcpip_connect(""))
                {
                    return;
                }
                string errtxt = "";
                foreach (string com in ComboBox_com.Items)
                {
                    foreach (string Baud in comboBox_Baud.Items)
                    {
                        if (com_connect(com, Baud, ref errtxt))
                        {
                            ComboBox_com.Text = com;
                            comboBox_Baud.Text = Baud;
                            return;
                        }
                    }
                }
                MessageBox.Show(nofindreader, nofindreader, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }

        private void btn_tcpipconnect_Click(object sender, EventArgs e)
        {
            if (comboBox_ip.Text.Trim() == "")
            {
                comboBox_ip.Focus();
                return;
            }
            if (serialPort1.IsOpen) btn_closecom_Click(null, null);
            btn_tcpipconnect.Enabled = false;
            if (!Tcpip_connect(comboBox_ip.Text))
            {
                MessageBox.Show(scanreader_fail, nofindreader, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            btn_tcpipconnect.Enabled = true;
        }

        private bool Tcpip_connect(string IP)
        {
            if (searchReader(IP))
            {
                if (Creat_tcpconnect())
                {
                    reader_Addr = ReadAddr();
                    if (reader_Addr == 0) return false;
                    if(!getDB_tcpip()) return false ;

                    dataGridView1.Rows.Clear();
                    reader_type = _reader_tcpip;
                    label9.Text = ComputerIP[0];
                    label11.Text = ComputerIP[1];
                    label13.Text = ComputerIP[2];
                    label11.Visible = label12.Visible = label13.Visible = label14.Visible = true;
                    comboBox_ip.Text = ComputerIP[0];
                    tabControl1.SelectedIndex = 0;
                    panel1.Enabled = true;
                    addinfo(scanreader_ok + "-TCP/IP", false);
                    if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
                    {
                        getTagbtn_Click(null, null);
                    }
                    return true;
                }
            }
            return false;
        }
        /// <summary>
        /// Search reader and setting
        /// </summary>
        /// <param name="IP"> computer ip </param>
        /// <returns></returns>
        private bool searchReader(string IP)
        {
            if (m_tcpClient != null)
            {
                return true;
            }

            panel1.Enabled = false;
            label11.Visible = label12.Visible = label13.Visible = label14.Visible = true;
            label10.Text = "IP：";
            label9.Text = "";

            reader_name.Text = reader_ip.Text = reader_SubnetMask.Text = reader_Gateway.Text = reader_mac.Text = "";

            reader.Ip_Address.IP = null;
            int docount = 0;
            bool result = false;
            byte[] data = reader.GetReader_list();
            addinfo(scanreader, false);
            while (docount++ < 2)
            {
                result = read_message(data);
                if (result) break;
            }
            if (result == false)
            {
                if (IP != "") addinfo(scanreader_fail, true);
                return false;
            }

            int network_count = 0;
            Class3.getNetwork(ref network_info, ref network_count); //取本机IP 子网掩码 网关
            if (network_count == 0)  //没有网卡
            {
                if (IP != "") addinfo(getlocalfail, true);
                return false;
            }

            if (IP.Trim() == "" && network_count > 1)  //没有指定 ip
            {

                Form3 frm = new Form3();
                DataGridView grid1 = frm.grid1;
                for (int i = 0; i < network_count; i++)
                {
                    grid1.Rows.Add(); ;
                    grid1[0, grid1.Rows.Count - 1].Value = network_info[i, 3];
                    grid1[1, grid1.Rows.Count - 1].Value = network_info[i, 0];
                    grid1[2, grid1.Rows.Count - 1].Value = network_info[i, 1];
                    grid1[3, grid1.Rows.Count - 1].Value = network_info[i, 2];
                }
                if (frm.ShowDialog(this) != DialogResult.OK)
                {
                    return false;
                }
                ComputerIP[0] = grid1[1, grid1.SelectedRows[0].Index].Value.ToString();
                ComputerIP[1] = grid1[2, grid1.SelectedRows[0].Index].Value.ToString();
                ComputerIP[2] = grid1[3, grid1.SelectedRows[0].Index].Value.ToString();
            }
            else
            {
                int index = 0;
                if (IP.Trim() != "")
                {
                    for (index = 0; index < network_count; index++)
                    {
                        if (IP == network_info[index, 0]) break;
                    }
                    if (index >= network_count)
                    {
                        addinfo("The ip address not found", true);
                        return false;
                    }
                }
                ComputerIP[0] = network_info[index, 0];
                ComputerIP[1] = network_info[index, 1];
                ComputerIP[2] = network_info[index, 2];
            }
            string[] tmp1 = reader.Ip_Address.IP.Split('.');
            string[] localtion = ComputerIP[0].Split('.');

            if (reader.Ip_Address.SubnetMask != ComputerIP[1] || reader.Ip_Address.Gateway != ComputerIP[2] || tmp1[0] != localtion[0] || tmp1[1] != localtion[1] || tmp1[2] != localtion[2] || reader.Ip_Address.IP == ComputerIP[0]) //网段不同或掩码不同或网关不同
            {
                if (IP != "") addinfo(ip_fail, true);

                string newip = Class3.ScanTarget(localtion[0] + "." + localtion[1] + "." + localtion[2]); //获取局域网一个空闲IP
                if (string.IsNullOrEmpty(newip)) return false;

                data = reader.SETReader(newip, ComputerIP[1], ComputerIP[2], reader.Ip_Address.MAC); //设置reader IP
                if (read_message(data))
                {
                    reader_ip.Text = newip;
                    reader_SubnetMask.Text = ComputerIP[1];
                    reader_Gateway.Text = ComputerIP[2];
                    if (IP != "") addinfo(set_ok, false);
                }
                else
                {
                    if (IP != "") addinfo(set_fail, true);
                    return false;
                }
            }
            data = reader.Set_WorkMode(ComputerIP[0], reader.Ip_Address.MAC); //设置工作模式
            if (!read_message(data))
            {
                return false;
            }
            return true;
        }
        private bool Creat_tcpconnect()
        {
            if (m_tcpClient != null)
            {
                if (m_tcpClient.Connected) return true;
            }
            else
            {
                try
                {
                    int port = int.Parse(comboBox_port.Text);
                    IPAddress localAddr = IPAddress.Parse(comboBox_ip.Text);

                    m_sockListener = new TcpListener(localAddr, port);
                }
                catch { }
            }
            m_sockListener.Start(5);
            int delaytime = 150;
            while (m_sockListener.Pending() || delaytime-- > 0)
            {
                try
                {
                    m_tcpClient = m_sockListener.AcceptTcpClient();//侦听到连接后创建客户端连接TcpClient 
                    return true;
                }
                catch{}
                Thread.Sleep(100);
                Application.DoEvents();
            }
            return false;
        }
        private byte ReadAddr()
        {
            byte addr = 0;

            byte[] sendBuf = new byte[] { 0xff, 0xff, 0x08, 0xee, 0xee };
            NetworkStream netStream;
            try
            {
                netStream = m_tcpClient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, 5);
            }
            catch (Exception exp)
            {
                addinfo(exp.Message,true);
                return 0;
            }

            for (int i = 0; i < 20;i++)
            {
                int count = m_tcpClient.Available;

                if (count >= 5)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 5 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[3] == 0xEE && recvBuf[4] == 0xEE)
                        {
                            addr = recvBuf[2];
                            break;
                        }
                    }
                    catch (Exception exp)
                    {
                        addinfo(exp.Message,true);
                        return 0;
                    }
                }
                Thread.Sleep(50);
            }
            return addr;
        }
        /***************************************************TCPIP connect END***************************************************************************/

        private void btn_opencom_Click(object sender, EventArgs e)
        {
            if (ComboBox_com.Text == "")
            {
                ComboBox_com.Focus();
                return;
            }
            if (serialPort1.IsOpen) return;

            string errtxt = "";
            if (!com_connect(ComboBox_com.Text, comboBox_Baud.Text,ref errtxt))
            {
                MessageBox.Show(errtxt != "" ? errtxt : nofindreader+"   ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private bool com_connect(string com,string Baud,ref string errtxt)
        {
            try
            {
                panel1.Enabled = false;
                serialPort1.PortName = com;
                serialPort1.BaudRate = int.Parse(Baud);
                serialPort1.Open();
                if (getDB_com())
                {

                    btn_opencom.Enabled = false;
                    btn_closecom.Enabled = true;
                    reader_type = _reader_com;
                    addinfo(scanreader_ok + com, false);
                    label11.Visible = label12.Visible = label13.Visible = label14.Visible = false;
                    label10.Text = "COM:";
                    label9.Text = com;
                    tabControl1.SelectedIndex = 1;
                    panel1.Enabled = true;
                    if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
                    {
                        getTagbtn_Click(null, null);
                    }
                    return true;
                }
                serialPort1.Close();
                return false;
            }
            catch (Exception err)
            {
                if (com != "")
                {
                    addinfo(err.Message, true);
                }
                errtxt = err.Message;
                return false;
            }
        }
        private void btn_closecom_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                if(!string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
                {
                    getTagbtn_Click(null, null);
                }
                serialPort1.Close();
                btn_opencom.Enabled = true;
                btn_closecom.Enabled = false;
                panel1.Enabled = false;
            }
        }

        #endregion

        #region read tag 获取标签相关事件或函数


        private void timer1_Tick(object sender, EventArgs e)
        {
            if (reader_type == _reader_tcpip)
            {
                readtag_tcpip();
            }
            if(reader_type==_reader_com)
            {
                readtag_com();
            }
        }

        private void getTagbtn_Click(object sender, EventArgs e)
        {
            if (reader_type == "") return;

            if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
            {
                try
                {
                    
                   // if (reader_type == _reader_tcpip) tcp_reader.Start(ComputerIP[0] + "," + "10000");
                    timer1.Start();
                    addinfo(start_read, false);
                    groupBox4.Enabled = false;
                }
                catch (Exception err)
                {
                    addinfo(err.Message, true);
                }
            }
            else
            {
                timer1.Stop();
                addinfo(stop_read, false);
               // tcp_reader.Stop();
                groupBox4.Enabled = true;
            }
            getTagbtn.Text = string.IsNullOrEmpty(getTagbtn.Tag.ToString()) ? "Stop" : "Read Tag";
            getTagbtn.Tag = string.IsNullOrEmpty(getTagbtn.Tag.ToString()) ? "1" : "";
        }
        private void readtag_tcpip()
        {
            if (m_tcpClient != null)
            {
                if (m_tcpClient.Connected == false)
                {
                    if (Creat_tcpconnect() == false) return;
                }
            }

            byte Addr = reader_Addr;
            byte[] sendBuf = new byte[] { Addr, 4, 1, 3 };
            byte[] recvBuf = new byte[4096];
            int recvBufLen = 0;
            try
            {
                NetworkStream netStream = m_tcpClient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, 4);
                recvBufLen = 0;

                Thread.Sleep(50);
                for (int i = 0; i < 20;i++)
                {
                    int count = m_tcpClient.Available;
                    if (count > 0)
                    {
                        int dataLen = netStream.Read(recvBuf, recvBufLen, count);
                        recvBufLen += dataLen;

                        if (recvBufLen >= 6)
                        {
                            if (recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[2] == Addr)
                            {
                                if (recvBuf[recvBufLen - 2] == 0xEE && recvBuf[recvBufLen - 1] == 0xEE)
                                {
                                    #region 2字节标签
                                    #endregion

                                    #region 5字节标签
                                    //5byte:ff ff 01 00 xx xx xx xx xx...ee ee

                                    List<TAGDATA> listTag = new List<TAGDATA>();

                                    for (int j = 4; j < recvBufLen - 6; j += 5)
                                    {
                                        bool bVolt = ((recvBuf[j] & 0x80) == 0x80);

                                        uint tagID = (uint)(recvBuf[j + 1]);
                                        tagID <<= 8;
                                        tagID |= recvBuf[j + 2];
                                        tagID <<= 8;
                                        tagID |= recvBuf[j + 3];
                                        tagID <<= 8;
                                        tagID |= recvBuf[j + 4];
                                        tag_show(Addr.ToString (),tagID.ToString (),DateTime.Now.ToShortTimeString());

                                    }
                                    #endregion
                                    break;
                                }
                            }
                            else
                            {//数据格式错误
                                break;
                            }
                        }
                    }
                    Thread.Sleep(50);
                }
            }
            catch (Exception exp)
            {
                addinfo(exp.Message,true);
            }
        }
        private bool readtag_com()
        {
            if (!serialPort1.IsOpen)
            {
                addinfo("Please open the serial port", true);
                return false;
            }

            byte addr = 1;
            m_sendBuf[0] = addr;
            m_sendBuf[1] = 4;
            m_sendBuf[2] = 1;
            m_sendBuf[3] = 3;

            serialPort1.DiscardOutBuffer();
            serialPort1.DiscardInBuffer();

            serialPort1.Write(m_sendBuf, 0, 4);
            while (serialPort1.BytesToWrite != 0) ;

            int revLength = 0;
            for (int i = 0; i < 10; i++)
            {
                int cbRead = serialPort1.BytesToRead;

                if (cbRead > 0)
                {
                    int num = serialPort1.Read(m_revBuf, revLength, cbRead);
                    revLength += num;

                    if (revLength >= 6 && m_revBuf[0] == 0xFF && m_revBuf[1] == 0xFF && m_revBuf[2] == addr && m_revBuf[revLength - 1] == 0xEE && m_revBuf[revLength - 2] == 0xEE)
                    {
                        //byte param = m_revBuf[startPos + 3];

                        if (m_nTagByteSize == 2)
                        {
                            #region  2字节读卡器
                            if ((revLength - 6) % 2 == 0)
                            {
                                //2字节 ff ff 01 00 xx xx ee ee
                                for (int j = 4; j < revLength - 3; j += 2)
                                {
                                    byte volt = (byte)((m_revBuf[j] & 0x80) >> 7);

                                    UInt32 tagID = (UInt32)(((m_revBuf[j] & 0x7F) << 8) | m_revBuf[j + 1]);
                                    tag_show(addr.ToString(), tagID.ToString(), DateTime.Now.ToLongTimeString());
                                }
                            }
                            #endregion
                        }
                        else if (m_nTagByteSize == 5)
                        {
                            #region 5字节读卡器
                            if ((revLength - 6) % 5 == 0)
                            {
                                //5字节
                                for (int j = 4; j < revLength - 5; j += 5)
                                {
                                    byte volt = (byte)(m_revBuf[j] >> 7);

                                    UInt32 tagID = m_revBuf[j + 1];
                                    tagID <<= 8;
                                    tagID |= m_revBuf[j + 2];
                                    tagID <<= 8;
                                    tagID |= m_revBuf[j + 3];
                                    tagID <<= 8;
                                    tagID |= m_revBuf[j + 4];

                                    tag_show(addr.ToString(), tagID.ToString(), DateTime.Now.ToLongTimeString());
                                }
                            }
                            #endregion
                        }
                        else
                        { }

                        return true;
                    }
                }

                System.Threading.Thread.Sleep(50);
            }
            addinfo("Read data failed！", true);
            return false;
        }
        #endregion

        #region    衰减值读取与设置

        //读取衰减值
        private void btnItemGetDB_Click(object sender, EventArgs e)
        {
            textBoxReaderDB.Text = "";
            if (reader_type == _reader_com) //com reader
            {
                if (getDB_com())
                {
                    addinfo("Get Power sucessfully！", false);
                }
                else
                {
                    addinfo("Get Power failed！", true);
                }
            }
            else   //tcpip reader
            {
                getDB_tcpip();
            }

        }
         //设置衰减值
        private void btnItemSetDB_Click(object sender, EventArgs e)
        {
            if (textBoxReaderDB.Text.Trim() == "")
            {
                textBoxReaderDB.Focus();
                return;
            }
            if (reader_type == _reader_com) //com reader
            {
                setDB_com();
            }
            else   //tcpip reader
            {
                setDB_tcpip();
            }
        }

        private bool getDB_tcpip()
        {
            byte Addr = reader_Addr;
            byte[] sendBuf = new byte[] { Addr, 0x04, 0x4c, 0x03 };

            NetworkStream netStream;
            try
            {
                netStream = m_tcpClient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, sendBuf[1]);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return false;
            }

            for (int i = 0; i < 20; i++)
            {
                int count = m_tcpClient.Available;

                if (count >= 6)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 6 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[4] == 0xEE && recvBuf[5] == 0xEE)
                        {
                            byte btDB = recvBuf[3];
                            textBoxReaderDB.Text = (31 - btDB).ToString();
                            addinfo("Get Power sucessfully！", false);
                            return true;
                        }
                    }
                    catch { }
                }
                System.Threading.Thread.Sleep(50);
            }
            addinfo("Get Power failed", true);
            return false;
        }
        private void setDB_tcpip()
        {
            byte Addr = reader_Addr;
            byte btDB = 0;

            try
            {
                btDB = byte.Parse(textBoxReaderDB.Text.Trim());
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }
            if (btDB > 31) btDB = 31;
            btDB = (byte)(31 - btDB);

            byte[] sendBuf = new byte[] { Addr, 0x05, 0xcc, btDB, 0x03 };

            NetworkStream netStream;
            try
            {
                netStream = m_tcpClient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, sendBuf[1]);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }

            for (int i = 0; i < 20; i++)
            {
                int count = m_tcpClient.Available;

                if (count >= 6)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 6 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[3] == btDB && recvBuf[4] == 0xEE && recvBuf[5] == 0xEE)
                        {
                            addinfo("Set Power sucessfully！", false);
                            return;
                        }
                    }
                    catch { }
                }
                System.Threading.Thread.Sleep(50);
            }
            addinfo("Set Power failed", true);
        }
        private bool getDB_com()
        {
            if (!serialPort1.IsOpen)
            {
                MessageBox.Show("Please open the serial port", "tip");
                return false;
            }

            byte addr = 1;
            m_sendBuf[0] = addr;
            m_sendBuf[1] = 0x04;
            m_sendBuf[2] = 0x4c;
            m_sendBuf[3] = 0x03;

            serialPort1.Write(m_sendBuf, 0, 4);

            for (int i = 0; i < 10; i++)
            {
                if (serialPort1.BytesToRead >= 6)
                {
                    int len = serialPort1.Read(m_revBuf, 0, 6);


                    if (m_revBuf[0] == 0xFF && m_revBuf[1] == 0xFF && m_revBuf[4] == 0xEE && m_revBuf[5] == 0xEE)
                    {
                        textBoxReaderDB.Text =(31-m_revBuf[3]).ToString();
                        return true;
                    }
                    else
                        break;
                }
                System.Threading.Thread.Sleep(30);
            }
            return false;
        }


        private void setDB_com()
        {
            if (!serialPort1.IsOpen)
            {
                MessageBox.Show("Please open the serial port", "tip");
                return;
            }

            byte addr = 1;
            byte btDB = 0;

            try
            {
                btDB = byte.Parse(textBoxReaderDB.Text.Trim());
                if (btDB > 31) btDB = 31;
                btDB =(byte)( 31 - btDB);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }

            m_sendBuf[0] = addr;
            m_sendBuf[1] = 0x05;
            m_sendBuf[2] = 0xcc;
            m_sendBuf[3] = btDB;
            m_sendBuf[4] = 3;

            serialPort1.Write(m_sendBuf, 0, 5);

            for (int i = 0; i < 10; i++)
            {
                if (serialPort1.BytesToRead >= 6)
                {
                    int len = serialPort1.Read(m_revBuf, 0, 6);

                    if (m_revBuf[0] == 0xFF && m_revBuf[1] == 0xFF && m_revBuf[3] == btDB && m_revBuf[4] == 0xEE && m_revBuf[5] == 0xEE)
                    {
                        addinfo("Set Power sucessfully！", false);
                        return;
                    }
                    else
                        break;
                }
                System.Threading.Thread.Sleep(30);
            }

            addinfo("Set Power failed", true);
        }
        #endregion
    }
}